### 4.54 `setbuf`—specify full buffering for a file or stream

Synopsis

         #include <stdio.h>
         void setbuf(FILE *fp, char *buf);

Description
`setbuf` specifies that output to the file or stream identified by fp should be fully buffered. All output for this file will go to a buffer (of size `BUFSIZ`, specified in ``stdio.h`'). Output will be passed on to the host system only when the buffer is full, or when an input operation intervenes.

You may, if you wish, supply your own buffer by passing a pointer to it as the argument buf. It must have size `BUFSIZ`. You can also use `NULL` as the value of buf, to signal that the `setbuf` function is to allocate the buffer.

Warnings
You may only use `setbuf` before performing any file operation other than opening the file.

If you supply a non-null buf, you must ensure that the associated storage continues to be available until you close the stream identified by fp.

Returns
`setbuf` does not return a result.

Portability
Both ANSI C and the System V Interface Definition (Issue 2) require `setbuf`. However, they differ on the meaning of a `NULL` buffer pointer: the SVID issue 2 specification says that a `NULL` buffer pointer requests unbuffered output. For maximum portability, avoid `NULL` buffer pointers.

Supporting OS subroutines required: `close`, `fstat`, `isatty`, `lseek`, `read`, `sbrk`, `write`.